
#ifndef _APP_CONFIG_H_
#define _APP_CONFIG_H_

#include <mega128.h>
#include <delay.h>
#include <stdio.h>
#include <stdlib.h>
#include <sleep.h>
#include <string.h>

typedef signed char             int8;
typedef unsigned char           uint8;
typedef signed int              int16;
typedef unsigned int            uint16;
typedef signed long int         int32;
typedef unsigned long int       uint32;

#define PGM_P                                   char flash *
#define PROGMEM                                 flash
#define PSTR(x)                                 x
#define pgm_read_byte(x)                        (*((uint8 flash *)(x)))
#define pgm_read_word(x)                        (*((uint16 flash *)(x)))
#define EEMEM                                   eeprom
#define eeprom_read_byte(ads)                   (*((uint8 eeprom *)(ads)))
#define eeprom_write_byte(ads,x)                (*((uint8 eeprom *)(ads))) = x
#define eeprom_write_word(ads,x)                (*((uint16 eeprom *)(ads))) = x
#define NOP()                                   #asm("nop")
#define SEI()                                   #asm("sei")
#define CLI()                                   #asm("cli")
#define _delay_ms                               delay_ms
#define ISR(vec)                                interrupt [vec] void isr##vec(void)
#define _BV(pin)                                (1<<(pin))
#define set(port,pin)                           port |= _BV(pin)
#define reset(port,pin)                         port &= ~_BV(pin)
#define bit_is_set(port,pin)		        (port & _BV(pin))
#define loop_until_bit_is_set( port, pin)       while (!bit_is_set(port,pin));
 
#define LCDCLS()                                LCDFillRect(0,LCD_SIZE_X-1,0,LCD_SIZE_Y-1,LCD_COL_WHITE,LCD_MODE_NORMAL)
#define LCD_BL_ON                               OCR1AL = LCD_BL;//set(LCD_BL_PRT,LCD_BL_BIT)
#define LCD_BL_OF                               OCR1AL = 0x00; //reset(LCD_BL_PRT,LCD_BL_BIT)
#define LCD_ORN_PORTRAIT       
#define so_pos_t	                        short
#define ADC_VREF_TYPE 0xC0

#asm
   .equ __w1_port = 0x18
   .equ __w1_bit = 7
#endasm

eeprom uint8  Evolume;
char   data[64];
uint8  buffer[512];
uint8  LCD_BL = 100;
uint8  LCD_VN = 12;
uint16 temp;
uint16 t_lcd;
uint16 VBAT;
uint16 zVBAT;
uint8  cVBAT;
uint8  ndirs;
uint8  nlist;
uint8  Cdir;
uint8  Clist;
uint8  ds_data[9];	
uint8  f_pos;
uint8  volume;
uint8  devices;
uint8  us,Time1;
uint8  Time2;
uint8  c_key;
uint8  f_key;
uint8  f_sleep;
uint8  start;
       
#include "TOOLS\FAT\diskio.h"
#include "TOOLS\CONFIG\hw_mcu.h"
#include "TOOLS\TEMP\ds18x20.c"
#include "TOOLS\RTC\rtc.c"
#include "TOOLS\SPI\spi.c"
#pragma promotechar+
#include "TOOLS\LCD\ili9325.c"
#pragma promotechar-
#include "TOOLS\TSCRIN\ads7846.c"
#include "TOOLS\TSCRIN\ts_tools.c"
#include "TOOLS\MMC\mmc.c"
#include "TOOLS\FAT\option\ccsbcs.c"
#include "TOOLS\FAT\ff.c"
#include "TOOLS\FAT\file_tools.c"
#include "TOOLS\ID3\ID3.c"

#include "TOOLS\BMP\sdbmp.c"
#include "TOOLS\VS1003B\VS1003B.c"

RTC rtc;

#endif
