

#include "TOOLS\LCD\font_courier.h"

#ifdef LCD_ORN_PORTRAIT
#define LCD_SIZE_X                                       240
#define LCD_SIZE_Y                                       320
#define LCD_VAL_ENTRY_MOD                                0x0030
#define LCD_INS_GRAM_ADX                                 LCD_INS_GRAM_HOR_AD
#define LCD_INS_GRAM_ADY                                 LCD_INS_GRAM_VER_AD
#define LCD_INS_START_ADX                                LCD_INS_HOR_START_AD
#define LCD_INS_END_ADX                                  LCD_INS_HOR_END_AD
#define LCD_INS_START_ADY                                LCD_INS_VER_START_AD
#define LCD_INS_END_ADY                                  LCD_INS_VER_END_AD
#else
#define LCD_SIZE_X                                       320
#define LCD_SIZE_Y                                       240
#define LCD_VAL_ENTRY_MOD                                0x0028
#define LCD_INS_GRAM_ADX                                 LCD_INS_GRAM_VER_AD
#define LCD_INS_GRAM_ADY                                 LCD_INS_GRAM_HOR_AD
#define LCD_INS_START_ADX                                LCD_INS_VER_START_AD
#define LCD_INS_END_ADX                                  LCD_INS_VER_END_AD
#define LCD_INS_START_ADY                                LCD_INS_HOR_START_AD
#define LCD_INS_END_ADY                                  LCD_INS_HOR_END_AD
#endif

/* LCD_ORN_PORTRAIT == 0x00
  _________________________
 \ ___________________    \
 \\                   \[] \
 \\   ------------    \[] \
 \\         /         \[] \
 \\   ------------>   \[] \
 \\___________________\[] \
 \________________________\
  
 LCD_ORN_PORTRAIT == 0x01
  ____________
 \ ---------- \
 \\          \\
 \\          \\
 \\  ------  \\
 \\       /  \\
 \\     /    \\
 \\   /      \\
 \\  ------> \\
 \\__________\\
 \ [][][][][] \
 \____________\
*/

#define LCD_INS_START_OSC			0x00 //data read at this instruction should be 0x0789 --> use for test connection
#define LCD_INS_DRIV_OUT_CTRL		        0x01
#define LCD_INS_DRIV_WAV_CTRL		        0x02
#define LCD_INS_ENTRY_MOD			0x03
#define LCD_INS_RESIZE_CTRL			0x04
#define LCD_INS_DISP_CTRL1			0x07
#define LCD_INS_DISP_CTRL2			0x08
#define LCD_INS_DISP_CTRL3			0x09
#define LCD_INS_DISP_CTRL4			0x0A
#define LCD_INS_RGB_DISP_IF_CTRL1	        0x0C
#define LCD_INS_FRM_MARKER_POS		        0x0D
#define LCD_INS_RGB_DISP_IF_CTRL2	        0x0F
#define LCD_INS_POW_CTRL1			0x10
#define LCD_INS_POW_CTRL2			0x11
#define LCD_INS_POW_CTRL3			0x12
#define LCD_INS_POW_CTRL4			0x13
#define LCD_INS_GRAM_HOR_AD			0x20
#define LCD_INS_GRAM_VER_AD			0x21
#define LCD_INS_RW_GRAM				0x22
#define LCD_INS_POW_CTRL7			0x29
#define LCD_INS_FRM_RATE_COL_CTRL	        0x2B
#define LCD_INS_GAMMA_CTRL1			0x30
#define LCD_INS_GAMMA_CTRL2			0x31
#define LCD_INS_GAMMA_CTRL3			0x32
#define LCD_INS_GAMMA_CTRL4			0x35
#define LCD_INS_GAMMA_CTRL5			0x36
#define LCD_INS_GAMMA_CTRL6			0x37
#define LCD_INS_GAMMA_CTRL7			0x38
#define LCD_INS_GAMMA_CTRL8			0x39
#define LCD_INS_GAMMA_CTRL9			0x3C
#define LCD_INS_GAMMA_CTRL10			0x3D
#define LCD_INS_HOR_START_AD			0x50
#define LCD_INS_HOR_END_AD			0x51
#define LCD_INS_VER_START_AD			0x52
#define LCD_INS_VER_END_AD			0x53
#define LCD_INS_GATE_SCAN_CTRL1		        0x60
#define LCD_INS_GATE_SCAN_CTRL2		        0x61
#define LCD_INS_GATE_SCAN_CTRL3		        0x6A
#define LCD_INS_PART_IMG1_DISP_POS	        0x80
#define LCD_INS_PART_IMG1_START_AD	        0x81
#define LCD_INS_PART_IMG1_END_AD		0x82
#define LCD_INS_PART_IMG2_DISP_POS	        0x83
#define LCD_INS_PART_IMG2_START_AD	        0x84
#define LCD_INS_PART_IMG2_END_AD		0x85
#define LCD_INS_PANEL_IF_CTRL1		        0x90
#define LCD_INS_PANEL_IF_CTRL2		        0x92
#define LCD_INS_PANEL_IF_CTRL3		        0x93
#define LCD_INS_PANEL_IF_CTRL4		        0x95
#define LCD_INS_PANEL_IF_CTRL5		        0x97
#define LCD_INS_PANEL_IF_CTRL6		        0x98

#define LCD_COL_RED				0x001F
#define LCD_COL_GREEN				0x0700
#define LCD_COL_BLUE				0xF800
#define LCD_COL_YELLOW				0x07FF
#define LCD_COL_PURPLE				0xF81F
#define LCD_COL_BLACK				0x0000
#define LCD_COL_WHITE				0xFFFF
#define code(codemem)				codemem
#define LCD_pos_t			        int

#define BLACK                       RGB(0x00, 0x00, 0x00)
#define WHITE                       RGB(0xFF, 0xFF, 0xFF)
#define RED                         RGB(0xFF, 0x00, 0x00)
#define GREEN                       RGB(0x00, 0xFF, 0x00)
#define BLUE                        RGB(0x00, 0x00, 0xFF)
#define YELLOW                      RGB(0xFF, 0xFF, 0x00)
#define MAGENTA                     RGB(0xFF, 0x00, 0xFF)
#define CYAN                        RGB(0x00, 0xFF, 0xFF)
#define GRAY                        RGB(0x80, 0x80, 0x40)
#define SILVER                      RGB(0xA0, 0xA0, 0x80)
#define GOLD                        RGB(0xA0, 0xA0, 0x40)

typedef enum
        {
        LCD_MODE_NORMAL,
        LCD_MODE_INVERSE,
        LCD_MODE_FULL
        } LCD_mode_t;

void LCDOutIns(unsigned short ins); //write instruction to LCD
void LCDOutDat(unsigned short dat); //write data to LCD
void LCDOutDat2(unsigned char dath,unsigned char datl); //write data to LCD
unsigned short LCDInIns(void); //read data from LCD
unsigned short LCDInDat(void); //read data from LCD

void LCDRst(void); //pulse reset signal to LCD
void LCDInit(void); //initial LCD

void LCDShowPicBack(LCD_pos_t sx,LCD_pos_t ex,LCD_pos_t sy,LCD_pos_t ey,const unsigned short *pic,unsigned int total_x,unsigned int total_y,LCD_mode_t mode);
//show picture from code memory with specific range and size
void LCDShowPic2(LCD_pos_t sx,LCD_pos_t ex,LCD_pos_t sy,LCD_pos_t ey,flash unsigned short *pic,LCD_mode_t mode);
//show picture from code memory with specific size
void LCDFillRect(LCD_pos_t sx,LCD_pos_t ex,LCD_pos_t sy,LCD_pos_t ey,unsigned short color,LCD_mode_t mode); //draw a rectangular
void LCDFillCirc(LCD_pos_t cx,LCD_pos_t cy,LCD_pos_t rad,unsigned short color, LCD_mode_t mode); //draw a circle
void LCDSetMargins(LCD_pos_t xl,LCD_pos_t xr,LCD_pos_t yu,LCD_pos_t yl); //set margins for FillRect,FillCirc
void LCDSetMarginsDefault(void); //reset margins to default value
void LCDSetFontColor(unsigned short color); //set text's color
void LCDSetBackColor(unsigned short color); //set back color for LCD_MODE_FULL
void LCDSetOffset(LCD_pos_t x,LCD_pos_t y); //set LCD offset for character display
void LCDPrintStr(unsigned char line,unsigned char column,char *str,LCD_mode_t mode); //print string on LCD
void LCDPrintTxt(unsigned char line,unsigned char column,const char *txt,LCD_mode_t mode); //print text from code memory
void LCDPrintCh(unsigned char line,unsigned char column,char c,LCD_mode_t mode); //print a character on LCD
unsigned int LCDGetCharWidth(char c); //get printed width of character
unsigned int LCDGetStringWidth(char *str); //get printed width of string
void LCDSetBold(unsigned char on); //set bold character mode
unsigned char LCDGetBold(void); //get bold character mode
void LCDSetVaryWidth(unsigned char on); //enable variable character width
unsigned char LCDGetVaryWidth(void); //get variable character width enabling
void LCDCfgFont(flash unsigned char *_font, unsigned char width, unsigned char height_div_8,unsigned char gap); //set font, font size
void LCDCharDisp(char charactor,LCD_pos_t sx,LCD_pos_t sy,LCD_mode_t mode); //low level function to print a character on LCD

const unsigned char *font;
unsigned char FONT_BIT_WIDTH = 9;
unsigned char FONT_BYTE_HEIGHT = 2;
int FONT_SIZE = 18;
unsigned char FONT_WIDTH = 9;
unsigned char FONT_HEIGHT = 16;
unsigned char char_gap = 2;

unsigned char char_buf[24][4];

void buf_store(unsigned char charactor);

unsigned short font_color;
unsigned short back_color;
LCD_pos_t offsetx,offsety;
LCD_pos_t LCD_margin_xl = 0;
LCD_pos_t LCD_margin_xr = LCD_SIZE_X - 1;
LCD_pos_t LCD_margin_yu = 0;
LCD_pos_t LCD_margin_yl = LCD_SIZE_Y - 1;

unsigned char bold_on = 0;
unsigned char first_non_zero;
unsigned char last_non_zero;
unsigned char vary_width_on = 0;

#define LCDGetMarginXl()                        LCD_margin_xl
#define LCDGetMarginXr()                        LCD_margin_xr
#define LCDGetMarginYu()                        LCD_margin_yu
#define LCDGetMarginYl()                        LCD_margin_yl

void LCDSetFontColor(unsigned short color) //set text's color
        {
        font_color = color;
        }

void LCDSetBackColor(unsigned short color) //set back color for LCD_MODE_FULL
        {
        back_color = color;
        }

void LCDOutDat(unsigned short dat) //write data to LCD
        {
        set(LCD_RS_PRT,LCD_RS_BIT);
        set(LCD_RD_PRT,LCD_RD_BIT);
        reset(LCD_WR_PRT,LCD_WR_BIT);
        LCD_DB_DDR = 0xFF;
        LCD_DB_PRT = dat >> 8;
        reset(LCD_CS_PRT,LCD_CS_BIT);
        set(LCD_CS_PRT,LCD_CS_BIT);
        LCD_DB_PRT = dat;
        reset(LCD_CS_PRT,LCD_CS_BIT);
        set(LCD_CS_PRT,LCD_CS_BIT);
        set(LCD_WR_PRT,LCD_WR_BIT);
        LCD_DB_DDR = 0;
        }

void LCDOutDat2(unsigned char dath,unsigned char datl) //write data to LCD
        {
        set(LCD_RS_PRT,LCD_RS_BIT);
        set(LCD_RD_PRT,LCD_RD_BIT);
        reset(LCD_WR_PRT,LCD_WR_BIT);
        LCD_DB_DDR = 0xFF;
        LCD_DB_PRT = dath;
        reset(LCD_CS_PRT,LCD_CS_BIT);
        set(LCD_CS_PRT,LCD_CS_BIT);
        LCD_DB_PRT = datl;
        reset(LCD_CS_PRT,LCD_CS_BIT);
        set(LCD_CS_PRT,LCD_CS_BIT);
        set(LCD_WR_PRT,LCD_WR_BIT);
        LCD_DB_DDR = 0;
        }

void LCDOutIns(unsigned short ins) //write instruction to LCD
        {
        reset(LCD_RS_PRT,LCD_RS_BIT);
        set(LCD_RD_PRT,LCD_RD_BIT);
        reset(LCD_WR_PRT,LCD_WR_BIT);
        LCD_DB_DDR = 0xFF;
        LCD_DB_PRT = ins >> 8;
        reset(LCD_CS_PRT,LCD_CS_BIT);
        set(LCD_CS_PRT,LCD_CS_BIT);
        LCD_DB_PRT = ins;
        reset(LCD_CS_PRT,LCD_CS_BIT);
        set(LCD_CS_PRT,LCD_CS_BIT);
        set(LCD_WR_PRT,LCD_WR_BIT);
        LCD_DB_DDR = 0;
        }

unsigned short LCDInDat(void) //read data from LCD
        {
        unsigned short dat = 0;
        LCD_DB_DDR = 0;
        set(LCD_RS_PRT,LCD_RS_BIT);
        set(LCD_WR_PRT,LCD_WR_BIT);
        reset(LCD_RD_PRT,LCD_RD_BIT);  
        reset(LCD_CS_PRT,LCD_CS_BIT);
        reset(LCD_CS_PRT,LCD_CS_BIT);
        dat = LCD_DB_PIN;
        set(LCD_CS_PRT,LCD_CS_BIT);
        dat <<= 8;
        reset(LCD_CS_PRT,LCD_CS_BIT);
        reset(LCD_CS_PRT,LCD_CS_BIT);
        dat |= LCD_DB_PIN;
        set(LCD_CS_PRT,LCD_CS_BIT);
        set(LCD_RD_PRT,LCD_RD_BIT);
        return (dat);
        }

unsigned short LCDInIns(void) //read data from LCD
        {
        unsigned short ins = 0;    
        LCD_DB_DDR = 0;  
        reset(LCD_RS_PRT,LCD_RS_BIT);
        set(LCD_WR_PRT,LCD_WR_BIT);
        reset(LCD_RD_PRT,LCD_RD_BIT);
        reset(LCD_CS_PRT,LCD_CS_BIT);
        reset(LCD_CS_PRT,LCD_CS_BIT);
        ins = LCD_DB_PIN;
        set(LCD_CS_PRT,LCD_CS_BIT);  
        ins <<= 8;
        reset(LCD_CS_PRT,LCD_CS_BIT);
        reset(LCD_CS_PRT,LCD_CS_BIT);
        ins |= LCD_DB_PIN;
        set(LCD_CS_PRT,LCD_CS_BIT);  
        set(LCD_RD_PRT,LCD_RD_BIT);
        return (ins);
        }

void LCDRst(void) //pulse reset signal to LCD
        {
        set(LCD_RST_DDR,LCD_RST_BIT);
        reset(LCD_RST_PRT,LCD_RST_BIT);
        delay_ms(50);
        set(LCD_RST_PRT,LCD_RST_BIT);
        }

void LCDInit(void) //initial LCD
        {
        unsigned short driver_code;
        delay_ms(100);
        LCDOutIns(LCD_INS_START_OSC);
        driver_code = LCDInDat();
        if (driver_code == 0x9320) //ILI9320
                {
                LCDOutIns(0x00E5);
                LCDOutDat(0x8000);                                         //set the internal vcore voltage
                LCDOutIns(LCD_INS_START_OSC);
                LCDOutDat(0x0001);                                         //start oscillator
                delay_ms(50);
                LCDOutIns(LCD_INS_DRIV_OUT_CTRL);
                LCDOutDat(0x0100);                                         //set SS, SM
                LCDOutIns(LCD_INS_DRIV_WAV_CTRL);
                LCDOutDat(0x0700);                                         //set 1 line inversion
                LCDOutIns(LCD_INS_ENTRY_MOD);
                LCDOutDat(LCD_VAL_ENTRY_MOD);                           //set GRAM write direction, BGR=0
                LCDOutIns(LCD_INS_RESIZE_CTRL);
                LCDOutDat(0x0000);                                         //no resizing
                LCDOutIns(LCD_INS_DISP_CTRL2);
                LCDOutDat(0x0202);                                         //front & back porch periods = 2
                LCDOutIns(LCD_INS_DISP_CTRL3);
                LCDOutDat(0x0000);                                         
                LCDOutIns(LCD_INS_DISP_CTRL4);
                LCDOutDat(0x0000);                                         
                LCDOutIns(LCD_INS_RGB_DISP_IF_CTRL1);
                LCDOutDat(0x0000);                                         //select system interface                                
                LCDOutIns(LCD_INS_FRM_MARKER_POS);
                LCDOutDat(0x0000);                                         
                LCDOutIns(LCD_INS_RGB_DISP_IF_CTRL2);
                LCDOutDat(0x0000);                                        
                LCDOutIns(LCD_INS_POW_CTRL1);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_POW_CTRL2);
                LCDOutDat(0x0000);                                         
                LCDOutIns(LCD_INS_POW_CTRL3);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_POW_CTRL4);
                LCDOutDat(0x0000);                                         
                delay_ms(200);
                LCDOutIns(LCD_INS_POW_CTRL1);
                LCDOutDat(0x17B0);
                LCDOutIns(LCD_INS_POW_CTRL2);
                LCDOutDat(0x0137);                                         
                delay_ms(50);
                LCDOutIns(LCD_INS_POW_CTRL3);
                LCDOutDat(0x013C);
                delay_ms(50);
                LCDOutIns(LCD_INS_POW_CTRL4);
                LCDOutDat(0x1400);
                LCDOutIns(LCD_INS_POW_CTRL7);
                LCDOutDat(0x0007);
                delay_ms(50);
                LCDOutIns(LCD_INS_GRAM_HOR_AD);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_GRAM_VER_AD);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_GAMMA_CTRL1);
                LCDOutDat(0x0007);
                LCDOutIns(LCD_INS_GAMMA_CTRL2);
                LCDOutDat(0x0504);
                LCDOutIns(LCD_INS_GAMMA_CTRL3);
                LCDOutDat(0x0703);
                LCDOutIns(LCD_INS_GAMMA_CTRL4);
                LCDOutDat(0x0002);
                LCDOutIns(LCD_INS_GAMMA_CTRL5);
                LCDOutDat(0x0707);
                LCDOutIns(LCD_INS_GAMMA_CTRL6);
                LCDOutDat(0x0406);
                LCDOutIns(LCD_INS_GAMMA_CTRL7);
                LCDOutDat(0x0006);
                LCDOutIns(LCD_INS_GAMMA_CTRL8);
                LCDOutDat(0x0404);
                LCDOutIns(LCD_INS_GAMMA_CTRL9);
                LCDOutDat(0x0700);
                LCDOutIns(LCD_INS_GAMMA_CTRL10);
                LCDOutDat(0x0A08);
                LCDOutIns(LCD_INS_HOR_START_AD);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_HOR_END_AD);
                LCDOutDat(0x00EF);
                LCDOutIns(LCD_INS_VER_START_AD);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_VER_END_AD);
                LCDOutDat(0x013F);
                LCDOutIns(LCD_INS_GATE_SCAN_CTRL1);
                LCDOutDat(0x2700);
                LCDOutIns(LCD_INS_GATE_SCAN_CTRL2);
                LCDOutDat(0x0001);
                LCDOutIns(LCD_INS_GATE_SCAN_CTRL3);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PART_IMG1_DISP_POS);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PART_IMG1_START_AD);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PART_IMG1_END_AD);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PART_IMG2_DISP_POS);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PART_IMG2_START_AD);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PART_IMG2_END_AD);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PANEL_IF_CTRL1);
                LCDOutDat(0x0010);
                LCDOutIns(LCD_INS_PANEL_IF_CTRL2);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PANEL_IF_CTRL3);
                LCDOutDat(0x0003);
                LCDOutIns(LCD_INS_PANEL_IF_CTRL4);
                LCDOutDat(0x0110);
                LCDOutIns(LCD_INS_PANEL_IF_CTRL5);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PANEL_IF_CTRL6);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_DISP_CTRL1);
                LCDOutDat(0x0173);
                }
        if (driver_code == 0x9325) //ILI9325
                {
                LCDOutIns(0x00E3);
                LCDOutDat(0x3008);                                         //set the internal timing
                LCDOutIns(0x00E7);
                LCDOutDat(0x0012);                                         //set the internal timing
                LCDOutIns(0x00EF);
                LCDOutDat(0x1231);                                         //set the internal timing
                LCDOutIns(LCD_INS_START_OSC);
                LCDOutDat(0x0001);                                         //start oscillator
                delay_ms(50);
                LCDOutIns(LCD_INS_DRIV_OUT_CTRL);
                LCDOutDat(0x0100);                                         //set SS, SM
                LCDOutIns(LCD_INS_DRIV_WAV_CTRL);
                LCDOutDat(0x0700);                                         //set 1 line inversion
                LCDOutIns(LCD_INS_ENTRY_MOD);
                LCDOutDat(LCD_VAL_ENTRY_MOD);                        //set GRAM write direction, BGR=0
                LCDOutIns(LCD_INS_RESIZE_CTRL);
                LCDOutDat(0x0000);                                         //no resizing
                LCDOutIns(LCD_INS_DISP_CTRL2);
                LCDOutDat(0x0202);                                         //front & back porch periods = 2
                LCDOutIns(LCD_INS_DISP_CTRL3);
                LCDOutDat(0x0000);                                         
                LCDOutIns(LCD_INS_DISP_CTRL4);
                LCDOutDat(0x0000);                                         
                LCDOutIns(LCD_INS_RGB_DISP_IF_CTRL1);
                LCDOutDat(0x0000);                                         //select system interface                                
                LCDOutIns(LCD_INS_FRM_MARKER_POS);
                LCDOutDat(0x0000);                                         
                LCDOutIns(LCD_INS_RGB_DISP_IF_CTRL2);
                LCDOutDat(0x0000);                                        
                LCDOutIns(LCD_INS_POW_CTRL1);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_POW_CTRL2);
                LCDOutDat(0x0007);                                         
                LCDOutIns(LCD_INS_POW_CTRL3);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_POW_CTRL4);
                LCDOutDat(0x0000);                                         
                delay_ms(200);
                LCDOutIns(LCD_INS_POW_CTRL1);
                LCDOutDat(0x1690);
                LCDOutIns(LCD_INS_POW_CTRL2);
                LCDOutDat(0x0227); //LCDOutDat(0x0137);                                         
                delay_ms(50);
                LCDOutIns(LCD_INS_POW_CTRL3);
                LCDOutDat(0x001A); //LCDOutDat(0x013C);
                delay_ms(50);
                LCDOutIns(LCD_INS_POW_CTRL4);
                LCDOutDat(0x1800); //LCDOutDat(0x1400);
                LCDOutIns(LCD_INS_POW_CTRL7);
                LCDOutDat(0x002A); //LCDOutDat(0x0007);
                delay_ms(50);
                LCDOutIns(LCD_INS_GRAM_HOR_AD);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_GRAM_VER_AD);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_GAMMA_CTRL1);
                LCDOutDat(0x0007);
                LCDOutIns(LCD_INS_GAMMA_CTRL2);
                LCDOutDat(0x0605);
                LCDOutIns(LCD_INS_GAMMA_CTRL3);
                LCDOutDat(0x0106);
                LCDOutIns(LCD_INS_GAMMA_CTRL4);
                LCDOutDat(0x0206);
                LCDOutIns(LCD_INS_GAMMA_CTRL5);
                LCDOutDat(0x0808);
                LCDOutIns(LCD_INS_GAMMA_CTRL6);
                LCDOutDat(0x0007);
                LCDOutIns(LCD_INS_GAMMA_CTRL7);
                LCDOutDat(0x0201);
                LCDOutIns(LCD_INS_GAMMA_CTRL8);
                LCDOutDat(0x0007);
                LCDOutIns(LCD_INS_GAMMA_CTRL9);
                LCDOutDat(0x0602);
                LCDOutIns(LCD_INS_GAMMA_CTRL10);
                LCDOutDat(0x0808);
                LCDOutIns(LCD_INS_HOR_START_AD);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_HOR_END_AD);
                LCDOutDat(0x00EF);
                LCDOutIns(LCD_INS_VER_START_AD);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_VER_END_AD);
                LCDOutDat(0x013F);
                LCDOutIns(LCD_INS_GATE_SCAN_CTRL1);
                LCDOutDat(0xA700);
                LCDOutIns(LCD_INS_GATE_SCAN_CTRL2);
                LCDOutDat(0x0001);
                LCDOutIns(LCD_INS_GATE_SCAN_CTRL3);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PART_IMG1_DISP_POS);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PART_IMG1_START_AD);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PART_IMG1_END_AD);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PART_IMG2_DISP_POS);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PART_IMG2_START_AD);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PART_IMG2_END_AD);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PANEL_IF_CTRL1);
                LCDOutDat(0x0010);
                LCDOutIns(LCD_INS_PANEL_IF_CTRL2);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PANEL_IF_CTRL3);
                LCDOutDat(0x0003);
                LCDOutIns(LCD_INS_PANEL_IF_CTRL4);
                LCDOutDat(0x0110);
                LCDOutIns(LCD_INS_PANEL_IF_CTRL5);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_PANEL_IF_CTRL6);
                LCDOutDat(0x0000);
                LCDOutIns(LCD_INS_DISP_CTRL1);
                LCDOutDat(0x0133);
                }
        }
/*
//show picture from Bg 
void LCDShowPicBack(LCD_pos_t sx,LCD_pos_t ex,LCD_pos_t sy,LCD_pos_t ey,const unsigned short *pic,unsigned int total_x,unsigned int total_y,LCD_mode_t mode)
//show picture from code memory with specific size
        {
        unsigned long k,p;
        unsigned short color;
        unsigned int x,y;
        unsigned int i,j;

        p=sy*total_x+sx;
        k=p;
        if (sx < LCD_margin_xl)
                sx = LCD_margin_xl;
        if (ex > LCD_margin_xr)
                ex = LCD_margin_xr;
        if (sy < LCD_margin_yu)
                sy = LCD_margin_yu;
        if (ey > LCD_margin_yl)                         
                ey = LCD_margin_yl;

        LCDOutIns(LCD_INS_START_ADX);
        LCDOutDat(sx);
        LCDOutIns(LCD_INS_END_ADX);
        LCDOutDat(ex);
        LCDOutIns(LCD_INS_GRAM_ADX);
        LCDOutDat(sx);
        x = ex - sx + 1;
#ifndef LCD_ORN_PORTRAIT
        sy = LCD_SIZE_Y - 1 - sy;         // mirror start y address
        ey = LCD_SIZE_Y - 1 - ey;         // mirror end y address
        LCDOutIns(LCD_INS_START_ADY);
        LCDOutDat(ey);
        LCDOutIns(LCD_INS_END_ADY);
        LCDOutDat(sy);
        LCDOutIns(LCD_INS_GRAM_ADY);
        LCDOutDat(sy);//fix from bug of v1_00
        y = sy - ey + 1;
#else
        LCDOutIns(LCD_INS_START_ADY);
        LCDOutDat(sy);
        LCDOutIns(LCD_INS_END_ADY);
        LCDOutDat(ey);
        LCDOutIns(LCD_INS_GRAM_ADY);
        LCDOutDat(sy);
        y = ey - sy + 1;
#endif
        LCDOutIns(LCD_INS_RW_GRAM);
        if (mode == LCD_MODE_FULL)
                {
                for (j=sy; j<(sy+y); j++)
                        for (i=p; i<p+x; i++)
                                {
                                LCDOutDat(code(pic[k]));
                                k++;
                                }
                }
        else if (mode == LCD_MODE_NORMAL)
                {
                for (j=sy; j<(sy+y); j++)
                        {
                        for (i=p; i<(p+x); i++)
                                {
                                if (code(pic[k]) == LCD_COL_WHITE)
                                        {
                                        color = LCDInDat();                 // ignore invalid data
                                        color = LCDInDat();
                                        LCDOutDat(color);
                                        }
                                else
                                        {
                                        LCDOutDat(code(pic[k]));
                                        }
                                k++;
                                }
                        k+=total_x-x;
                        }
                }
        }
*/

void LCDShowPic2(LCD_pos_t sx,LCD_pos_t ex,LCD_pos_t sy,LCD_pos_t ey,flash unsigned short *pic,LCD_mode_t mode)
//show picture from code memory with specific size
        {
        unsigned long k = 0;
        unsigned short color;
        unsigned int x,y;
        unsigned int i,j;
        if (sx < LCD_margin_xl)
                sx = LCD_margin_xl;
        if (ex > LCD_margin_xr)
                ex = LCD_margin_xr;
        if (sy < LCD_margin_yu)
                sy = LCD_margin_yu;
        if (ey > LCD_margin_yl)                         
                ey = LCD_margin_yl;

        LCDOutIns(LCD_INS_START_ADX);
        LCDOutDat(sx);
        LCDOutIns(LCD_INS_END_ADX);
        LCDOutDat(ex);
        LCDOutIns(LCD_INS_GRAM_ADX);
        LCDOutDat(sx);
        x = ex - sx + 1;

#ifndef LCD_ORN_PORTRAIT
        sy = LCD_SIZE_Y - 1 - sy;         // mirror start y address
        ey = LCD_SIZE_Y - 1 - ey;         // mirror end y address
        LCDOutIns(LCD_INS_START_ADY);
        LCDOutDat(ey);
        LCDOutIns(LCD_INS_END_ADY);
        LCDOutDat(sy);
        LCDOutIns(LCD_INS_GRAM_ADY);
        LCDOutDat(sy);//fix from bug of v1_00
        y = sy - ey + 1;
#else
        LCDOutIns(LCD_INS_START_ADY);
        LCDOutDat(sy);
        LCDOutIns(LCD_INS_END_ADY);
        LCDOutDat(ey);
        LCDOutIns(LCD_INS_GRAM_ADY);
        LCDOutDat(sy);
        y = ey - sy + 1;
#endif

        LCDOutIns(LCD_INS_RW_GRAM);

        if (mode == LCD_MODE_FULL)
                {
                for (j=0; j<y; j++)
                        for (i=0; i<x; i++)
                                {
                                LCDOutDat(code(pic[k]));
                                k++;
                                }
                }
        else
        if (mode == LCD_MODE_NORMAL)
                {
                for (j=0; j<y; j++)
                        for (i=0; i<x; i++)
                                {
                                if (code(pic[k]) == LCD_COL_WHITE)
                                        {
                                        color = LCDInDat();                 // ignore invalid data
                                        color = LCDInDat();
                                        LCDOutDat(color);
                                        }
                                else
                                        {
                                        LCDOutDat(code(pic[k]));
                                        }
                                k++;
                                }
                }
        }

void LCDFillRect(LCD_pos_t sx,LCD_pos_t ex,LCD_pos_t sy,LCD_pos_t ey,unsigned short color,LCD_mode_t mode) //draw a rectangular
        {
        unsigned int x,y;
        unsigned int i,j;
        if (sx < LCD_margin_xl)
                sx = LCD_margin_xl;
        if (ex > LCD_margin_xr)
                ex = LCD_margin_xr;
        if (sy < LCD_margin_yu)
                sy = LCD_margin_yu;
        if (ey > LCD_margin_yl)                         
                ey = LCD_margin_yl;

        LCDOutIns(LCD_INS_START_ADX);
        LCDOutDat(sx);
        LCDOutIns(LCD_INS_END_ADX);
        LCDOutDat(ex);
        LCDOutIns(LCD_INS_GRAM_ADX);
        LCDOutDat(sx);
        x = ex - sx + 1;

#ifndef LCD_ORN_PORTRAIT
        sy = LCD_SIZE_Y - 1 - sy;         // mirror start y address
        ey = LCD_SIZE_Y - 1 - ey;         // mirror end y address
        LCDOutIns(LCD_INS_START_ADY);
        LCDOutDat(ey);
        LCDOutIns(LCD_INS_END_ADY);
        LCDOutDat(sy);
        LCDOutIns(LCD_INS_GRAM_ADY);
        LCDOutDat(sy);//fix from bug of v1_00
        y = sy - ey + 1;
#else
        LCDOutIns(LCD_INS_START_ADY);
        LCDOutDat(sy);
        LCDOutIns(LCD_INS_END_ADY);
        LCDOutDat(ey);
        LCDOutIns(LCD_INS_GRAM_ADY);
        LCDOutDat(sy);
        y = ey - sy + 1;
#endif

        LCDOutIns(LCD_INS_RW_GRAM);

        if ((mode == LCD_MODE_NORMAL) || (mode == LCD_MODE_FULL))
                {
                for (j=0; j<y; j++)
                        for (i=0; i<x; i++)
                                {
                                LCDOutDat(color);
                                }
                }
        else
        if (mode == LCD_MODE_INVERSE)
                {
                for (j=0; j<y; j++)
                        for (i=0; i<x; i++)
                               {
                                color = LCDInDat();                 // ignore invalid data
                                color = LCDInDat();
                                LCDOutDat(~color);
                                }
                }
        }

void LCDFillCirc(LCD_pos_t cx,LCD_pos_t cy,LCD_pos_t rad,unsigned short color, LCD_mode_t mode) //draw a circle
        {
#ifndef LCD_ORN_PORTRAIT
        int sy_buf,ey_buf;
#endif
        int sx,sy,ex,ey;
        int i,j;
        unsigned short color_buf;
        unsigned short rad2 = rad*rad;
        sx = cx - rad;
        ex = cx + rad;
        sy = cy - rad;
        ey = cy + rad;

        if (sx < LCD_margin_xl)
                sx = LCD_margin_xl;
        if (ex > LCD_margin_xr)
                ex = LCD_margin_xr;
        if (sy < LCD_margin_yu)
                sy = LCD_margin_yu;
        if (ey > LCD_margin_yl)                         
                ey = LCD_margin_yl;

        LCDOutIns(LCD_INS_START_ADX);
        LCDOutDat(sx);
        LCDOutIns(LCD_INS_END_ADX);
        LCDOutDat(ex);
        LCDOutIns(LCD_INS_GRAM_ADX);
        LCDOutDat(sx);
//        x = ex - sx + 1;

#ifndef LCD_ORN_PORTRAIT
        sy_buf = LCD_SIZE_Y - 1 - sy;         // mirror start y address
        ey_buf = LCD_SIZE_Y - 1 - ey;         // mirror end y address
        LCDOutIns(LCD_INS_START_ADY);
        LCDOutDat(ey_buf);
        LCDOutIns(LCD_INS_END_ADY);
        LCDOutDat(sy_buf);
        LCDOutIns(LCD_INS_GRAM_ADY);
        LCDOutDat(sy_buf);//fix from bug of v1_00
//        y = sy_buf - ey_buf + 1;
#else
        LCDOutIns(LCD_INS_START_ADY);
        LCDOutDat(sy);
        LCDOutIns(LCD_INS_END_ADY);
        LCDOutDat(ey);
        LCDOutIns(LCD_INS_GRAM_ADY);
        LCDOutDat(sy);
//        y = ey - sy + 1;
#endif

        LCDOutIns(LCD_INS_RW_GRAM);

        if (mode == LCD_MODE_NORMAL)
                {
                for (j=sy-cy; j<=ey-cy; j++)
                        for (i=sx-cx; i<=ex-cx; i++)
                                {
                                if ((i)*(i) + (j)*(j) < rad2)
                                        {
                                        LCDOutDat(color);
                                        }
                                else
                                        {
                                        color_buf = LCDInDat();                 // ignore invalid data
                                        color_buf = LCDInDat();
                                        LCDOutDat(color_buf);
                                        }
                                }
                }
        else
        if (mode == LCD_MODE_INVERSE)
                {
                for (j=sy-cy; j<=ey-cy; j++)
                        for (i=sx-cx; i<=ex-cx; i++)
                                {
                                if ((i)*(i) + (j)*(j) < rad2)
                                        {
                                        color_buf = LCDInDat();                 // ignore invalid data
                                        color_buf = LCDInDat();
                                        LCDOutDat(~color_buf);
                                        }
                                else
                                        {
                                        color_buf = LCDInDat();                 // ignore invalid data
                                        color_buf = LCDInDat();
                                        LCDOutDat(color_buf);
                                        }
                                }
                }
        else
        if (mode == LCD_MODE_FULL)
                {
                for (j=sy-cy; j<=ey-cy; j++)
                        for (i=sx-cx; i<=ex-cx; i++)
                                {
                                if ((i)*(i) + (j)*(j) < rad2)
                                        {
                                        LCDOutDat(color);
                                        }
                                else
                                        {
                                        LCDOutDat(back_color);
                                        }
                                }
                }
        }

void LCDSetMargins(LCD_pos_t xl,LCD_pos_t xr,LCD_pos_t yu,LCD_pos_t yl) //set margins for FillRect,FillCirc
        {
        LCD_margin_xl = xl;
        LCD_margin_xr = xr;
        LCD_margin_yu = yu;
        LCD_margin_yl = yl;
        }

void LCDSetMarginsDefault(void) //Reset margins to default value
        {
        LCD_margin_xl = 0;
        LCD_margin_xr = LCD_SIZE_X - 1;
        LCD_margin_yu = 0;
        LCD_margin_yl = LCD_SIZE_Y - 1;
        }

void buf_store(unsigned char charactor)
        {
        unsigned char i,j;
        int char_p = charactor*FONT_SIZE;

        first_non_zero = FONT_BIT_WIDTH;
        last_non_zero = 0;

        for (i=0; i<FONT_BIT_WIDTH; i++)
                for (j=0; j<FONT_BYTE_HEIGHT; j++)
                        {
                        if (font[char_p])
                                {
                                last_non_zero = i;
                                if (first_non_zero == FONT_BIT_WIDTH)
                                        {
                                        if (i)
                                                 first_non_zero = i-1;
                                        else
                                                first_non_zero = 0;
                                        }
                                }
                        if (bold_on && i)
                                char_buf[i][j] = font[char_p] | font[char_p-FONT_BYTE_HEIGHT];
                        else
                                char_buf[i][j] = font[char_p];
                        char_p++;
                        }

        if (bold_on)
                {
                last_non_zero++;
                }
        if (charactor == ' '-0x20)
                {          
                first_non_zero = 0;
                last_non_zero = FONT_BIT_WIDTH/2;
                }
        }

void buf_clear(void)
        {
        unsigned char i,j;

        for (i=0; i<FONT_BIT_WIDTH+2; i++)
                for (j=0; j<FONT_BYTE_HEIGHT; j++)
                        {
                        char_buf[i][j] = 0;
                        }
        }

unsigned char buf_read(unsigned char column,unsigned char row)
        {
        unsigned char read_pixel;

        if (vary_width_on)
                {
                column += first_non_zero;        
                }
        if (row < 8)
                {
                read_pixel = (char_buf[column][0] >> (7-row)) & 0x01;
                }
        else
                {
                row = row - 8;
                read_pixel = (char_buf[column][1] >> (7-row)) & 0x01;
                }
        return (read_pixel);
        }

void LCDCharDisp(char charactor,LCD_pos_t sx,LCD_pos_t sy,LCD_mode_t mode) //low level function to print a character on LCD
        {
        unsigned int x,y;
        unsigned char i,j;
        LCD_pos_t ex,ey;
        unsigned short c;

        buf_store(charactor - 0x20);

        if (vary_width_on)
                {
                ex = sx + (last_non_zero - first_non_zero) + char_gap - 1;
                }
        else
                {
                ex = sx + FONT_WIDTH - 1;
                }

        ey = sy + FONT_HEIGHT - 1;

        LCDOutIns(LCD_INS_START_ADX);
        LCDOutDat(sx);
        LCDOutIns(LCD_INS_END_ADX);
        LCDOutDat(ex);
        LCDOutIns(LCD_INS_GRAM_ADX);
        LCDOutDat(sx);
        x = ex - sx + 1;

#ifndef LCD_ORN_PORTRAIT
        sy = LCD_SIZE_Y - 1 - sy;         // mirror start y address
        ey = LCD_SIZE_Y - 1 - ey;         // mirror end y address
        LCDOutIns(LCD_INS_START_ADY);
        LCDOutDat(ey);
        LCDOutIns(LCD_INS_END_ADY);
        LCDOutDat(sy);
        LCDOutIns(LCD_INS_GRAM_ADY);
        LCDOutDat(sy);//fix from bug of v1_00
        y = sy - ey + 1;
#else
        LCDOutIns(LCD_INS_START_ADY);
        LCDOutDat(sy);
        LCDOutIns(LCD_INS_END_ADY);
        LCDOutDat(ey);
        LCDOutIns(LCD_INS_GRAM_ADY);
        LCDOutDat(sy);
        y = ey - sy + 1;
#endif

        LCDOutIns(LCD_INS_RW_GRAM);

        if (mode == LCD_MODE_NORMAL)
                {
                for (j=0; j<y; j++)
                        for (i=0; i<x; i++)
                                {
                                if (buf_read(i,j))
                                        {
                                        LCDOutDat(font_color);
                                        }
                                else
                                        {
                                        c = LCDInDat();                 // ignore invalid data
                                        c = LCDInDat();
                                        LCDOutDat(c);
                                        }
                                }
                }
        else
        if (mode == LCD_MODE_INVERSE)
                {
                for (j=0; j<y; j++)
                        for (i=0; i<x; i++)
                                {
                                c = LCDInDat();                         // ignore invalid data
                                c = LCDInDat();
                                if (buf_read(i,j))
                                        {
                                        LCDOutDat(~c);
                                        }
                                else
                                        {
                                        LCDOutDat(c);
                                        }
                                }
                }
        else
        if (mode == LCD_MODE_FULL)
                {
                for (j=0; j<y; j++)
                        for (i=0; i<x; i++)
                                {
                                if (buf_read(i,j))
                                        {
                                        LCDOutDat(font_color);
                                        }
                                else
                                        {
                                        LCDOutDat(back_color);
                                        }
                                }
                }
        }

void LCDSetOffset(LCD_pos_t x,LCD_pos_t y) //set LCD offset for character display
        {
        offsetx = x;
        offsety = y;
        }

void LCDPrintStr(unsigned char line,unsigned char column,char *str,LCD_mode_t mode) //print string on LCD
        {
        int i = 0;
        LCD_pos_t posx,posy;
        posx = offsetx + column*FONT_WIDTH;
        posy = offsety + line*FONT_HEIGHT;

        while(str[i])
                {
                LCDCharDisp(str[i],posx,posy,mode);
                if (vary_width_on)
                        posx += last_non_zero-first_non_zero+char_gap;
                else
                        posx += FONT_WIDTH;
//                if (bold_on)
//                        posx++;
                i++;
                }
        }

void LCDPrintTxt(unsigned char line,unsigned char column,const char *txt,LCD_mode_t mode) //print text from code memory
        {
        int i = 0;
        LCD_pos_t posx,posy;
        posx = offsetx + column*FONT_WIDTH;
        posy = offsety + line*FONT_HEIGHT;

        while(code(txt[i]))
                {
                LCDCharDisp(code(txt[i]),posx,posy,mode);
                if (vary_width_on)
                        posx += last_non_zero-first_non_zero+char_gap;
                else
                        posx += FONT_WIDTH;
//                if (bold_on)
//                        posx++;
                i++;
                }
        }

void LCDPrintCh(unsigned char line,unsigned char column,char c,LCD_mode_t mode) //print a character on LCD
        {
        LCD_pos_t posx,posy;
        posx = offsetx + column*FONT_WIDTH;
        posy = offsety + line*FONT_HEIGHT;

        LCDCharDisp(c,posx,posy,mode);
        }

unsigned int LCDGetCharWidth(char c)
        {
        unsigned int res;
        if (vary_width_on)
                {
                buf_store(c-0x20);
                res = last_non_zero - first_non_zero + char_gap;
                return (res);
                }
        else
                return (FONT_BIT_WIDTH);
        }

unsigned int LCDGetStringWidth(char *str)
        {
        unsigned int i = 0;
        unsigned int res = 0;
        while (str[i])
                {
                res += LCDGetCharWidth(str[i]);
                i++;
                }
        return (res);
        }

void LCDSetBold(unsigned char on)
        {
        bold_on = on;
        }
        
unsigned char LCDGetBold(void)
        {
        return (bold_on);
        }

void LCDSetVaryWidth(unsigned char on)
        {
        vary_width_on = on;
        }

unsigned char LCDGetVaryWidth(void)
        {
        return (vary_width_on);
        }

void LCDCfgFont(flash unsigned char *_font, unsigned char width, unsigned char height_div_8, unsigned char gap)
        {
        font = _font;
        FONT_BIT_WIDTH = width;
        FONT_BYTE_HEIGHT = height_div_8;
        FONT_SIZE = width*height_div_8;
        FONT_WIDTH = FONT_BIT_WIDTH;
        FONT_HEIGHT = FONT_BYTE_HEIGHT*8;
        char_gap = gap;
        buf_clear();  
        }

