
#include <1wire.h>

#define Max1wire                        4
#define Ds18b20_conf_reg                4
#define Ds18x20_fracconv                625
#define Ds18s20_id                      0x10
#define Ds18b20_id                      0x28
#define Ds18x20_convert_t               0x44
#define Ds18x20_read                    0xBE
#define Ds18x20_write                   0x4E
#define Ds18x20_ee_write                0x48
#define Ds18x20_ee_recall               0xB8
#define Ds18x20_read_power_supply       0xB4

extern struct __ds1820_struct
       {
       unsigned char    temp_lsb,temp_msb;
       signed char      temp_high,temp_low;
       unsigned char    res1,res2,cnt_rem,cnt_c,crc;
       } __ds1820;

unsigned char ds1820_select(unsigned char *addr);
unsigned char ds1820_read_spd(unsigned char *addr);
int ds1820_temperature_10(unsigned char *addr);
unsigned char ds1820_set_alarm(unsigned char *addr,signed char temp_low,signed char temp_high);

struct __ds1820_struct __ds1820;
       
unsigned char ds1820_select(unsigned char *addr)
        {
        unsigned char i;
        if (w1_init()==0) return 0;
        if (addr)
                {
                w1_write(0x55);
                i=0;
                do
                w1_write(*(addr++));
                while (++i<8);
                }
        else w1_write(0xcc);
        return 1;
        }

unsigned char ds1820_read_spd(unsigned char *addr)
        {
        unsigned char i;
        unsigned char *p;
        if (ds1820_select(addr)==0) return 0;
        w1_write(Ds18x20_read);
        i=0;
        p=(char *) &__ds1820;
        do
                *(p++)=w1_read();
        while (++i<9);
        return !w1_dow_crc8(&__ds1820,9);
        }

int ds1820_temperature_10(unsigned char *addr)
        {
        if (ds1820_select(addr)==0) return -9999;
        w1_write(Ds18x20_convert_t);
        delay_ms(10);
        if (ds1820_read_spd(addr)==0) return -9999;
        w1_init();
        return ((((((int)__ds1820.temp_msb<<8) | __ds1820.temp_lsb)*50)-25) + (((__ds1820.cnt_c - __ds1820.cnt_rem) * 100) / __ds1820.cnt_c)) / 10;
        }
/*
unsigned char ds1820_set_alarm(unsigned char *addr,signed char temp_low,signed char temp_high)
        {
        if (ds1820_select(addr)==0) return 0;
        w1_write(Ds18x20_write);
        w1_write(temp_high);
        w1_write(temp_low);
        if (ds1820_read_spd(addr)==0) return 0;
        if ((__ds1820.temp_low!=temp_low) || (__ds1820.temp_high!=temp_high)) return 0;
        if (ds1820_select(addr)==0) return 0;
        w1_write(Ds18x20_ee_write);
        delay_ms(15);
        return w1_init();
        } 
*/
