
#ifdef LCD_ORN_PORTRAIT
#define CAL_VALID                       0x02
#define TCGetH()                        TCGetY()
#define TCGetV()                        TCGetX()
#define EP_AD_CFG_CX                    13
#define EP_AD_CFG_M1X                   17
#define EP_AD_CFG_M2X                   21
#define EP_AD_CFG_CY                    1
#define EP_AD_CFG_M1Y                   5
#define EP_AD_CFG_M2Y                   9
#else
#define CAL_VALID                       0x01
#define TCGetH()                        TCGetX()
#define TCGetV()                        TCGetY()
#define EP_AD_CFG_CX                    1
#define EP_AD_CFG_M1X                   5
#define EP_AD_CFG_M2X                   9
#define EP_AD_CFG_CY                    13
#define EP_AD_CFG_M1Y                   17
#define EP_AD_CFG_M2Y                   21
#endif

const long chalfx = LCD_SIZE_X/2;
const long chalfy = LCD_SIZE_Y/2;
unsigned char filp_horizontal = 0;
eeprom unsigned char eeprom_buf[32];
typedef struct
        {
        unsigned char on;
        long x;
        long y;
        } pos_ts;

//x = ((TCGetH() - ccx)*cm1x)/cm2x + chalfx;
long ccx;
long cm1x;
long cm2x;

//y = ((TCGetV() - ccy)*cm1y)/cm2y + chalfy;
long ccy;
long cm1y;
long cm2y;

#define EP_SIZE                 4096
#define EP_AD_CFG               EP_SIZE - 128
#define EP_AD_CFG_STATUS        0

#define TC_TP_NUM               5
#define CAL_VALID_PORTRAIT      0x01
#define CAL_VALID_LANDSCAPE     0x02
#define EP_FIRST                1

#ifndef LCD_ORN_PORTRAIT
const int tc_tpy[TC_TP_NUM] = {10,65,120,175,230};//,230,175,120,65,10};//{10 ,32 ,54 ,76 ,98 ,120,142,164,186,208,230};//
const int tc_tpx[TC_TP_NUM] = {10,85,160,235,310};//,10,85,160,235,310};//{10 ,40 ,70 ,100,130,160,190,220,250,280,310};//
#else
const int tc_tpx[TC_TP_NUM] = {10,65,120,175,230};//,230,175,120,65,10};//{10 ,32 ,54 ,76 ,98 ,120,142,164,186,208,230};//
const int tc_tpy[TC_TP_NUM] = {10,85,160,235,310};//,10,85,160,235,310};//{10 ,40 ,70 ,100,130,160,190,220,250,280,310};//
#endif

//unsigned char last_pen_check = 0;
//so_pos_t hpos,vpos;

long cal_posx(unsigned short x)
{
        long buf;
        buf = x - ccx;
        buf = buf*cm1x;
        buf = buf/cm2x;
        buf = buf + chalfx;
#ifdef LCD_ORN_PORTRAIT
        if (filp_horizontal)
                return (LCD_SIZE_X - buf);
        else
#endif
                return (buf);
}

long cal_posy(unsigned short y)
{
        long buf;
        buf = y - ccy;
        buf = buf*cm1y;
        buf = buf/cm2y;
        buf = buf + chalfy;
#ifndef LCD_ORN_PORTRAIT
        if (filp_horizontal)
                return (LCD_SIZE_Y - buf);
        else
#endif
                return (buf);
}
        
pos_ts scan_pen(void)
        {
        unsigned short tc_x_buf,tc_y_buf;
        unsigned short tc_x_max,tc_y_max;
        unsigned short tc_x_min,tc_y_min;
        pos_ts pos;

        pos.on = 0;
        if (TCIsPenOn())
                {
                TCRead();
                tc_x_buf = TCGetH();
                tc_y_buf = TCGetV();

                tc_x_max = TCGetH();
                tc_y_max = TCGetV();
                tc_x_min = TCGetH();
                tc_y_min = TCGetV();

                TCRead();
                tc_x_buf += TCGetH();
                tc_y_buf += TCGetV();

                if (TCGetH() > tc_x_max)
                        tc_x_max = TCGetH();
                if (TCGetH() < tc_x_min)
                        tc_x_min = TCGetH();
                if (TCGetV() > tc_y_max)
                        tc_y_max = TCGetV();
                if (TCGetV() < tc_y_min)
                        tc_y_min = TCGetV();

                TCRead();
                tc_x_buf += TCGetH();
                tc_y_buf += TCGetV();

                if (TCGetH() > tc_x_max)
                        tc_x_max = TCGetH();
                if (TCGetH() < tc_x_min)
                        tc_x_min = TCGetH();
                if (TCGetV() > tc_y_max)
                        tc_y_max = TCGetV();
                if (TCGetV() < tc_y_min)
                        tc_y_min = TCGetV();

                TCRead();
                tc_x_buf += TCGetH();
                tc_y_buf += TCGetV();

                if (TCGetH() > tc_x_max)
                        tc_x_max = TCGetH();
                if (TCGetH() < tc_x_min)
                        tc_x_min = TCGetH();
                if (TCGetV() > tc_y_max)
                        tc_y_max = TCGetV();
                if (TCGetV() < tc_y_min)
                        tc_y_min = TCGetV();

                tc_x_buf -= tc_x_max;
                tc_x_buf -= tc_x_min;
                tc_y_buf -= tc_y_max;
                tc_y_buf -= tc_y_min;

                tc_x_buf = tc_x_buf >> 1;
                tc_y_buf = tc_y_buf >> 1;

                if (TCIsPenOn())
                        {
                        pos.x = cal_posx(tc_x_buf);
                        pos.y = cal_posy(tc_y_buf);
                        pos.on = 1;
                        }
                //pos.x += 20;      
#ifdef LCD_ORN_PORTRAIT 
                //pos.y += ((240 - pos.x)/3);
#endif
                }
        return (pos);
        }
        
//char hextable(unsigned char hex)
//        {
//        if (hex < 10)
//                return (hex + 0x30);
//        else
//                return (hex - 10 + 'A');
//        }

void AppCalibrateScreen(unsigned char wait_time)
        {
        pos_ts pos;
        unsigned char line;
        char str[32];
        long dat_buf;
        int buf;

        int x[TC_TP_NUM];
        int y[TC_TP_NUM];

        long sum_xx = 0;
        long sum_yy = 0;
        long sum_fx = 0;
        long sum_fy = 0;
        long sum_fxx = 0;
        long sum_fyy = 0;

        float cx;
        float mx;
        float cy;
        float my;

        float mx_new;
        float my_new;

        float buf_mod1;

        long fx[TC_TP_NUM];
        long fy[TC_TP_NUM];
        long xx[TC_TP_NUM];
        long yy[TC_TP_NUM];
        long fxx[TC_TP_NUM];
        long fyy[TC_TP_NUM];

        unsigned char i,j,k;
        unsigned char good_press;

        if ((eeprom_buf[EP_FIRST] == CAL_VALID_PORTRAIT) || 
                (eeprom_buf[EP_FIRST] == CAL_VALID_LANDSCAPE)) //check for valid touch screen calibration data
                {
                if (wait_time)
                        {
#ifdef LCD_ORN_PORTRAIT
                        line = 8;
#else
                        line = 5;
#endif
                        LCDFillRect(0,LCD_SIZE_X-1,0,LCD_SIZE_Y-1,LCD_COL_WHITE,LCD_MODE_NORMAL);
                        LCDSetOffset((LCD_SIZE_X-LCDGetStringWidth("Press the screen")) >> 1,0);
                        LCDPrintStr( line,0,"Press the screen",LCD_MODE_FULL);
                        line += 2;
                        LCDSetOffset((LCD_SIZE_X-LCDGetStringWidth("to recalibrate")) >> 1,0);
                        LCDPrintStr( line,0,"to recalibrate",LCD_MODE_FULL);
                        line += 2;
                        LCDSetOffset((LCD_SIZE_X-LCDGetStringWidth("within 3 seconds")) >> 1,0);
                        k = 0;
                        }
                 
                for (i=0;i<wait_time;i++)
                        {
                        sprintf(str,"within %d seconds ",wait_time-i);
                        LCDPrintStr( line,0,str,LCD_MODE_FULL);
                        for (j=0;j<10;j++)
                                {
                                if (TCIsPenOn())
                                        {
                                        k = 1;
                                        break;
                                        }
                                delay_ms(100);
                                }
                        if (k)
                                break;
                        }
                LCDSetOffset(0,0);

                if (k == 0) //use old data
                        {
                        if (eeprom_buf[EP_FIRST] != CAL_VALID)
                                filp_horizontal = 1;

                        ccx = 0;
                        for (i=0;i<4;i++) //sizeof long = 4
                                {
                                dat_buf = eeprom_buf[EP_FIRST + EP_AD_CFG_CX + i];
                                dat_buf        <<= i*8;
                                ccx |= dat_buf;
                                }
                                 
                        cm1x = 0;
                        for (i=0;i<4;i++) //sizeof long = 4
                                {
                                dat_buf = eeprom_buf[EP_FIRST + EP_AD_CFG_M1X + i];
                                dat_buf        <<= i*8;
                                cm1x |= dat_buf;
                                }
                                
                        cm2x = 0;
                        for (i=0;i<4;i++) //sizeof long = 4
                                {
                                dat_buf = eeprom_buf[EP_FIRST + EP_AD_CFG_M2X + i];
                                dat_buf        <<= i*8;
                                cm2x |= dat_buf;
                                }
                                 
                        ccy = 0;
                        for (i=0;i<4;i++) //sizeof long = 4
                                {
                                dat_buf = eeprom_buf[EP_FIRST + EP_AD_CFG_CY + i];
                                dat_buf        <<= i*8;
                                ccy |= dat_buf;
                                }
                                 
                        cm1y = 0;
                        for (i=0;i<4;i++) //sizeof long = 4
                                {
                                dat_buf = eeprom_buf[EP_FIRST + EP_AD_CFG_M1Y + i];
                                dat_buf        <<= i*8;
                                cm1y |= dat_buf;
                                }
                                
                        cm2y = 0;
                        for (i=0;i<4;i++) //sizeof long = 4
                                {
                                dat_buf = eeprom_buf[EP_FIRST + EP_AD_CFG_M2Y + i];
                                dat_buf        <<= i*8;
                                cm2y |= dat_buf;
                                }

                        return;
                        }
                }

        while(TCIsPenOn());

        LCDFillRect(0,LCD_SIZE_X-1,0,LCD_SIZE_Y-1,LCD_COL_WHITE,LCD_MODE_NORMAL);

        for (i=0; i<TC_TP_NUM; i++)
                {
                LCDFillCirc(tc_tpx[i],tc_tpy[i],8,LCD_COL_BLACK,LCD_MODE_FULL);
                LCDFillCirc(tc_tpx[i],tc_tpy[i],6,LCD_COL_WHITE,LCD_MODE_FULL);
                LCDFillRect(tc_tpx[i],tc_tpx[i],tc_tpy[i],tc_tpy[i],LCD_COL_BLACK,LCD_MODE_NORMAL);

                good_press = 0;
                while (!good_press)
                        {
                        while (!TCIsPenOn());
                        TCRead();
                        delay_ms(100);
                        if (TCIsPenOn())
                                {
                                TCRead();
                                delay_ms(100);
                                while (TCIsPenOn());
                                good_press = 1;
                                }
                        }
                fx[i] = TCGetH();
                fy[i] = TCGetV();

                LCDFillCirc(tc_tpx[i],tc_tpy[i],8,LCD_COL_WHITE,LCD_MODE_FULL);
                }

        for (i=0;i<TC_TP_NUM;i++)
                {
                x[i] = tc_tpx[i] - chalfx;
                y[i] = tc_tpy[i] - chalfy;
                xx[i] = x[i] * x[i];
                yy[i] = y[i] * y[i];
                fxx[i] = fx[i] * x[i];
                fyy[i] = fy[i] * y[i];
                }

        for (i=0;i<TC_TP_NUM;i++)
                {
                sum_xx += xx[i];
                sum_yy += yy[i];
                sum_fx += fx[i];
                sum_fy += fy[i];
                sum_fxx += fxx[i];
                sum_fyy += fyy[i];
                }

        cx = ((float)sum_fx) / ((float)(TC_TP_NUM));
        mx = ((float)sum_fxx) / ((float)sum_xx);
        cy = ((float)sum_fy) / ((float)(TC_TP_NUM));
        my = ((float)sum_fyy) / ((float)sum_yy);

        ccx = (long)cx;
        ccy = (long)cy;

        mx_new = mx;
        my_new = my;

        buf_mod1 = mx_new - (long)mx_new;
        if (buf_mod1 < 0)
                buf_mod1 = -buf_mod1;
        buf = 1;

        while ((buf_mod1 > 0.05) && (buf_mod1 < 0.95))
                {
                buf++;
                mx_new = mx*((float) buf);
                buf_mod1 = mx_new - (long)mx_new;
                if (buf_mod1 < 0)
                        buf_mod1 = -buf_mod1;
                }

        cm1x = buf;
        cm2x = (long)(mx * buf);

        buf_mod1 = my_new - (long)my_new;
        if (buf_mod1 < 0)
                buf_mod1 = -buf_mod1;
        buf = 1;

        while ((buf_mod1 > 0.05) && (buf_mod1 < 0.95))
                {
                buf++;
                 my_new = my*((float)buf);
                buf_mod1 = my_new - (long)my_new;
                if (buf_mod1 < 0)
                        buf_mod1 = -buf_mod1;
                }

        cm1y = buf;
        cm2y = (long)(my * buf);

        eeprom_buf[EP_FIRST] = CAL_VALID; //EP_AD_CFG_STATUS --> config data valid

        dat_buf = ccx;
        for (i=0;i<4;i++) //sizeof long = 4
                {
                eeprom_buf[EP_FIRST + EP_AD_CFG_CX + i] = dat_buf;
                dat_buf >>= 8;
                }

        dat_buf = cm1x;
        for (i=0;i<4;i++) //sizeof long = 4
                {
                eeprom_buf[EP_FIRST + EP_AD_CFG_M1X + i] = dat_buf;
                dat_buf >>= 8;
                }

        dat_buf = cm2x;
        for (i=0;i<4;i++) //sizeof long = 4
                {
                eeprom_buf[EP_FIRST + EP_AD_CFG_M2X + i] = dat_buf;
                dat_buf >>= 8;
                }

        dat_buf = ccy;
        for (i=0;i<4;i++) //sizeof long = 4
                {
                eeprom_buf[EP_FIRST + EP_AD_CFG_CY + i] = dat_buf;
                dat_buf >>= 8;
                }

        dat_buf = cm1y;
        for (i=0;i<4;i++) //sizeof long = 4
                {
                eeprom_buf[EP_FIRST + EP_AD_CFG_M1Y + i] = dat_buf;
                dat_buf >>= 8;
                }

        dat_buf = cm2y;
        for (i=0;i<4;i++) //sizeof long = 4
                {
                eeprom_buf[EP_FIRST + EP_AD_CFG_M2Y + i] = dat_buf;
                dat_buf >>= 8;
                }

        LCDFillRect(0,LCD_SIZE_X-1,0,LCD_SIZE_Y-1,LCD_COL_WHITE,LCD_MODE_NORMAL);
        line -= 4;
        LCDSetOffset((LCD_SIZE_X-LCDGetStringWidth("Now try pressing")) >> 1,0);
        LCDPrintStr( line,0,"Now try pressing",LCD_MODE_FULL);
        line += 2;
        LCDSetOffset((LCD_SIZE_X-LCDGetStringWidth("on the screen")) >> 1,0);
        LCDPrintStr( line,0,"on the screen",LCD_MODE_FULL);
        line += 2;
        LCDSetOffset((LCD_SIZE_X-LCDGetStringWidth("then please reset")) >> 1,0);
        LCDPrintStr( line,0,"then please reset",LCD_MODE_FULL);

        while (1)
                {
                pos = scan_pen();
                if (pos.on && pos.x && pos.y)
                        {
                        if((pos.x < LCD_SIZE_X) && (pos.y < LCD_SIZE_Y))
                                LCDFillCirc(pos.x,pos.y,1,LCD_COL_BLACK,LCD_MODE_NORMAL);  
                        else
                                LCDCLS();
                        //sprintf(data,"X%u/Y%u  ",pos.x,pos.y);
                        //LCDPrintStr(15,0,data,LCD_MODE_FULL);
                        }
                }
        }