
#include "TOOLS\CONFIG\app_config.h"

uint16 read_adc(uint8 adc_input)
        {
        ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
        delay_us(10);
        ADCSRA|=0x40;
        while ((ADCSRA & 0x10)==0);
        ADCSRA|=0x10;
        return ADCW;
        }
        
interrupt [EXT_INT7] void ext_int7_isr(void)
        {
        f_sleep = 1; 
        }
        
interrupt [TIM0_COMP] void timer0_comp_isr(void)
        {
        if(bit_is_set(KEY_PIN,KEY_BIT))
                {
                c_key = 0;
                f_key = 0;
                f_sleep = 0;
                }
        else if(!f_key)
                {
                if(c_key < 100) c_key++; 
                if(c_key > 50) 
                        {
                        if(!start)
                                {
                                c_key = 0;
                                f_key = 1;
                                start = 10;
                                t_lcd = 100;
                                }
                        else
                                {
                                WDTCR=0x18;
                                WDTCR=0x08;
                                while(1);
                                } 
                        }
                if(start)
                	{
                        t_lcd = 100;
                        LCD_BL_ON;
                        }
                } 
        if(us > 25)
                {
                us = 0;
                Time1++;
                if(Time2 > 0)Time2--;
                if(t_lcd > 0)
                        t_lcd--;
                else 
                        LCD_BL_OF;
                if(cVBAT < 10)
                	{
                        zVBAT += read_adc(0);
                        cVBAT++;
                        }
                else
                	{
                        VBAT = zVBAT / 20;
                        zVBAT = 0;
                        cVBAT = 0;
                        }
                 
                }
        else us++;
         
        if(!bit_is_set(TC_PEN_PIN,TC_PEN_BIT) && start && t_lcd)t_lcd = 100;
                
        disk_timerproc();
        }    
                               
void lcd_init(void)
        {
        set(LCD_RST_DDR,LCD_RST_BIT);
        reset(LCD_BL_PRT,LCD_BL_BIT);
        set(LCD_BL_DDR,LCD_BL_BIT);
        set(LCD_RS_DDR,LCD_RS_BIT);
        set(LCD_CS_DDR,LCD_CS_BIT);
        set(LCD_RD_DDR,LCD_RD_BIT);
        set(LCD_WR_DDR,LCD_WR_BIT);
        LCDRst();
        LCDInit();
        LCDSetFontColor(LCD_COL_BLACK);
        LCDSetBackColor(LCD_COL_WHITE);
	LCDCfgFont(font_vrinda11x16,11,2,2);
	LCDSetVaryWidth(1);
	LCDSetBold(0);
	LCDCLS();
        }

uint16 ScrollBar (uint16 x1,uint16 x2,uint16 y1,uint16 y2,uint16 tep,uint16 maxstep)
        {
        uint16 step;
        uint8  res,yy = (y2 - y1 - 6)/(maxstep-11);
        LCDFillRect(x1  ,x2  ,y1  ,y2  ,LCD_COL_WHITE,LCD_MODE_FULL);
        if(maxstep > 12)
        	{
                LCDFillRect(x1+4,x2-4,y1  ,y2  ,LCD_COL_BLACK ,LCD_MODE_FULL);
                LCDFillRect(x1+5,x2-5,y1+1,y2-1,LCD_COL_GREEN ,LCD_MODE_FULL);
                if(tep < y1+3)tep = y1 + 3;
                if(tep > y2-3-yy)tep = y2 - 3 - yy;
                res = (tep - y1) / ((y2 - y1) / (maxstep-11));
                LCDFillRect(x1  ,x2  ,tep ,tep+yy,LCD_COL_RED,LCD_MODE_FULL);
                return res;
        	}
        return 0;
        }
   
void volome_cotrol(uint8 Volin)
        {
        uint8 vol;
        char data[32];
        if(Volin > 20 && Volin < 120)
                {
                vol = 100-(Volin - 20);
                //LCD_BL = (Volin - 20) * 2.5;
                if(vol > 3)
                        { 
                        VS1003B_SetVolume((((WORD)(Volin - 20) << 8) | (Volin - 20)));
                        sprintf(data,"%u",vol);
                        LCDPrintStr(8,1,"   ",LCD_MODE_FULL);
                        LCDPrintStr(8,1,data,LCD_MODE_FULL);
                        }
                else
                       {
                       LCDPrintStr(8,1,"X ",LCD_MODE_FULL);
                       VS1003B_SetVolume(0xFEFE);
                       }  
                LCDFillRect(9  ,26 ,20 ,125 ,LCD_COL_WHITE,LCD_MODE_FULL);        
                LCDFillRect(15 ,20 ,20 ,125 ,LCD_COL_BLACK,LCD_MODE_FULL);
                LCDFillRect(16 ,19 ,21 ,124 ,LCD_COL_GREEN ,LCD_MODE_FULL);
                LCDFillRect(10 ,25 ,Volin ,Volin+5,LCD_COL_RED,LCD_MODE_FULL);
                }
        }
 
uint8 key_view (uint8 key)
	{
        switch (key) 
                {
                case 1:
                        bmpFile("SKIN/key1a.bmp");
                        return bmpShow(0,280);
                break;
                case 2:
                        bmpFile("SKIN/key2a.bmp");
                        return bmpShow(24,280);
                break;
                case 3:
                        bmpFile("SKIN/key3a.bmp");
                        return bmpShow(48,280);
                break;
                case 4:
                        bmpFile("SKIN/key4a.bmp");
                        return bmpShow(72,280);
                break;
                case 5:
                        bmpFile("SKIN/key5a.bmp");
                        return bmpShow(96,264);
                break;
                case 6:
                        bmpFile("SKIN/key6a.bmp");
                        return bmpShow(144,280);
                break;
                case 7:
                        bmpFile("SKIN/key7a.bmp");
                        return bmpShow(168,280);
                break; 
                case 8:
                        bmpFile("SKIN/key8a.bmp");
                        return bmpShow(192,280);
                break;
                case 9:
                        bmpFile("SKIN/key9a.bmp");
                        return bmpShow(216,280);
                break;
                case 10:
                        bmpFile("SKIN/key.bmp");
                        return bmpShow(0,264);
                break;
                case 11:
                        bmpFile("SKIN/key1b.bmp");
                        return bmpShow(0,280);
                break;
                case 12:
                        bmpFile("SKIN/key2b.bmp");
                        return bmpShow(24,280);
                break;
                case 13:
                        bmpFile("SKIN/key3b.bmp");
                        return bmpShow(48,280);
                break;
                case 14:
                        bmpFile("SKIN/key4b.bmp");
                        return bmpShow(72,280);
                break;
                case 15:
                        bmpFile("SKIN/key5b.bmp");
                        return bmpShow(96,264);
                break;
                case 16:
                        bmpFile("SKIN/key6b.bmp");
                        return bmpShow(144,280);
                break;
                case 17:
                        bmpFile("SKIN/key7b.bmp");
                        return bmpShow(168,280);
                break; 
                case 18:
                        bmpFile("SKIN/key8b.bmp");
                        return bmpShow(192,280);
                break;
                case 19:
                        bmpFile("SKIN/key9b.bmp");
                        return bmpShow(216,280);
                break;
                }
        }
static uint8 play_file (const char* fname)
        {
        AUDIO_INFO info;
        UINT   br;
        uint8  buffer[512];
        uint8  f_mute,f_ff,f_stop,f_puse; 
        uint8  listindex,s_key;
        pos_ts pos;
        char   data[64];
        char   titel[128];
                
        uint8  i,chr,len,flag,canter = 0; 
        uint16 count,decodetime,endtime,sdata = 0;
        FIL fil1;
         
        get_id3_tag(fname,titel);
        if (f_open(&fil1,fname,FA_READ) != FR_OK) return 2; 
        VS1003B_SoftReset();
        VS1003B_Fill2048Zero();
        volome_cotrol(volume);                   
        f_stop = 0;
        f_puse = 0;
        f_mute = 0;
        Time1 = 0;
        while(1)                             
                { 
                if(!f_stop && !f_puse)
                        {
                        f_read(&fil1,buffer, 512, &br); 
                        if (br < 512) 
                                {
                                return 10; // >
                                }
                        }
                for(count=0;count<16;)
                        {               
                        if(f_stop || f_puse)
                                {
                                count++;
                                flag = 1;
                                }
                        if((VS1003B_NeedData() && !f_stop && !f_puse) || f_ff)
                                {
                                if(!f_stop && !f_puse)VS1003B_Write32B(&buffer[count*32]);
                                count++;
                                flag = 1;
                                f_ff = 0;
                                }
                        else if(flag)
                                {   
                                flag = 0;
                                switch (count) 
                                        {
                                        case 2:
                                                VS1003_get_audio_info(&info); 
                                                sprintf(data,"%uKbps%uKhz ",info.bit_rate,info.sample_rate);
                                                LCDPrintStr(16,0,data,LCD_MODE_FULL);
                                                strcpyf(data,mode_values[info.mode]);
                                                LCDPrintStr(16,14,data,LCD_MODE_FULL);
                                                endtime = (fil1.fsize / (info.bit_rate * 1000)) * 3.9;
                                                decodetime = VS1003B_ReadDecodeTime();
                                                sprintf(data,"Time %u:%u ",endtime/60,endtime%60);
                                                LCDPrintStr(0,10,data,LCD_MODE_FULL);
                                                sprintf(data,"%u:%u ",decodetime/60,decodetime%60);
                                                LCDPrintStr(0,18,data,LCD_MODE_FULL);      
                                        break;
                                        case 10:
                                                decodetime = VS1003B_ReadDecodeTime();
                                                sprintf(data,"%u:%u ",decodetime/60,decodetime%60);
                                                LCDPrintStr(0,18,data,LCD_MODE_FULL);
                                        break; 
                                        case 4:
                                                rtc_gettime(&rtc);
                                                miltoshmcv(&rtc); 
                                                sprintf(data,"%u/%u/%u  ",rtc.year,rtc.month,rtc.mday);
                                                LCDPrintStr(19,0,data,LCD_MODE_FULL); 
                                                sprintf(data,"VB:%u.%2u  ",VBAT/100,VBAT%100);
                                                if(VBAT%100 < 10)data[5] = '0';
                                		LCDPrintStr(0,0,data,LCD_MODE_FULL); 
                                        break;
                                        case 12:
                                                rtc_gettime(&rtc);
                                                miltoshmcv(&rtc); 
                                                sprintf(data,"%u/%u/%u  ",rtc.year,rtc.month,rtc.mday);
                                                LCDPrintStr(19,0,data,LCD_MODE_FULL);  
                                        break;
                                        case 6:
                                                if(rtc.sec > 10 && rtc.sec < 20 && devices)
                                                        { 
                                                        temp = ds1820_temperature_10(&ds_data[0]);
                                                        sprintf(data,"%-i.%-u c   ",temp/10,abs(temp%10));
                                                        LCDPrintStr(19,14,data,LCD_MODE_FULL);
                                                        }
                                                else
                                                        {
                                                        sprintf(data,"%u:%u:%u  ",rtc.hour,rtc.min,rtc.sec);
                                                        LCDPrintStr(19,14,data,LCD_MODE_FULL);
                                                        }
                                        break; 
                                        case 14:
                                                if(rtc.sec > 10 && rtc.sec < 20 && devices)
                                                        { 
                                                        temp = ds1820_temperature_10(&ds_data[0]);
                                                        sprintf(data,"%-i.%-u c   ",temp/10,abs(temp%10));
                                                        LCDPrintStr(19,14,data,LCD_MODE_FULL);
                                                        }
                                                else
                                                        {
                                                        sprintf(data,"%u:%u:%u  ",rtc.hour,rtc.min,rtc.sec);
                                                        LCDPrintStr(19,14,data,LCD_MODE_FULL);
                                                        }
                                        break;
                                        default: 
                                                if(OCR1AL)pos = scan_pen();
                                                if (pos.on)
                                                        {
                                                        if(canter < 250)canter ++; 
                                                        }
                                                else 
                                                	{
                                                        canter = 0; 
                                                        f_pos = 0;
                                                        if(s_key)
                                                        	{
                                                                if(!key_view(s_key))s_key = 0;
                                                                }
                                                        }
                                                if (canter > 1)
                                                        { 
                                                        if(pos.x < 30 && pos.y < 120)
                                                                {
                                                                volume = pos.y;
                                                                volome_cotrol(volume);
                                                                f_mute = 0;
                                                                }
                                                        else if(pos.y > 276 && pos.y < 300 && !f_pos)
                                                                {
                                                                f_pos = 1;
                                                                if(pos.x < 24)
                                                                        { 
                                                                        key_view(11);
                                                                        s_key = 1;
                                                                        if(!f_mute)
                                                                                {
                                                                                f_mute = 1; 
                                                                                volome_cotrol(119);
                                                                                }
                                                                        else
                                                                                {
                                                                                f_mute = 0;
                                                                                volome_cotrol(volume);
                                                                                }
                                                                        }
                                                                else if(pos.x > 24 && pos.x < 48)
                                                                	{ 
                                                                        key_view(12);
                                                                        s_key = 2;
                                                                        return 11;// < 
                                                                        }
                                                                else if(pos.x > 48 && pos.x < 72)
                                                                	{
                                                                        key_view(13);
                                                                        s_key = 3;
                                                                        }
                                                                else if(pos.x > 72 && pos.x < 96)
                                                                        {
                                                                        key_view(14);
                                                                        s_key = 4;
                                                                        f_stop = 1;
                                                                        fil1.curr_clust = fil1.org_clust;
                                                                        VS1003B_SPI_Low();
                                                                        VS1003B_WriteCMD(0x04,0x00);
                                                                        }
                                                                else if(pos.x > 96 && pos.x < 145)
                                                                        { 
                                                                        key_view(15);
                                                                        s_key = 5;
                                                                        f_puse = 0;
                                                                        f_stop = 0;
                                                                        }
                                                                else if(pos.x > 145 && pos.x < 168)
                                                                	{
                                                                        key_view(16);
                                                                        f_puse = 1;
                                                                        s_key = 6;    
                                                                        }
                                                                else if(pos.x > 168 && pos.x < 192)
                                                                	{
                                                                        key_view(17);
                                                                        f_ff = 1;
                                                                        s_key = 7; 
                                                                        }
                                                                else if(pos.x > 192 && pos.x < 216)
                                                                	{
                                                                        key_view(18);
                                                                        s_key = 8;
                                                                        return 10; // >
                                                                        }
                                                                else if(pos.x > 216 && pos.x < 240)
                                                                	{
                                                                        key_view(19);
                                                                        s_key = 9;
                                                                        }
                                                                }
                                                        else if(pos.x > 200 && pos.y < 260)
                                                                {
                                                                listindex = ScrollBar(215,230,32,255,pos.y,nlist);
                                                                LCDFillRect(40,200,64,260,LCD_COL_WHITE,LCD_MODE_FULL);
                                                                LCDSetFontColor(LCD_COL_BLUE); 
                                                                for (Clist=0;Clist<LCD_VN;Clist++)
                                                                        { 
                                                                        if(ListTbl[Clist+listindex][_MAX_LFN] == AM_DIR)
                                                                                LCDSetBold(1);
                                                                        else
                                                                                LCDSetBold(0);
                                                                        LCDPrintStr(Clist+4,4,ListTbl[Clist+listindex],LCD_MODE_FULL);
                                                                        }
                                                                }
                                                        else if(pos.x > 32 && pos.x < 180 && pos.y > 25 && pos.y < 256)return 2;                                                         
                                                        else if(pos.x > 32 && pos.x < 180 && pos.y > 25 && pos.y < 50)return 2;
                                                        //else if (pos.x > 50 && pos.y > 45)return 11; 
                                                        }
                                                else
                                                        {
                                                        sdata = 0;
                                                        f_ff = 0;
                                                        }                                                  
                                                LCDSetVaryWidth(0);
                                                LCDSetFontColor(LCD_COL_RED);
                                                LCDSetBold(1);
                                                len = strlen(titel);
                                                for(i=0;i<16;i++)
                                                        {
                                                        if(Time1 > len + 15)Time1 = 0;
                                                        if(i+Time1 < len)
                                                                chr = titel[i+Time1];
                                                        else if(i+Time1 < len+16)
                                                                chr = ' ';
                                                        else
                                                                chr = titel[i + Time1 - len - 16];
                                                        LCDPrintCh(1,3+i,chr,LCD_MODE_FULL);
                                                        }
                                                LCDSetFontColor(LCD_COL_BLACK);
                                                LCDSetBold(0);
                                                LCDSetVaryWidth(1);
                                        break;
                                        }
                                }
                        }   
                }
        }
                              
void main(void)
        {   
        uint8 i,res,step = 0;
        uint16 sdata;
        uint8 canter,Strk,listindex;          
        FATFS fs; 
        DIR dir; 

        pos_ts pos;    

        char Cdir[64];
        char Cfile[64];
        char data[32];
        signed char s;
        mcu_init(); 
         
        reset(KEY_DDR,KEY_BIT);
        set(KEY_PRT,KEY_BIT);

        #asm("sei");
         
        start = 0; 
        f_key = 0;
         
        sleep:
        EIMSK=0x80;
        EIFR=0x80;
        sleep_enable(); 
        powerdown();
        while(!start)
                {
                if(!f_sleep)goto sleep;
                EIMSK=0x00;
                EIFR=0x00;
                sleep_disable(); 
                }
         
        rtc_init();
        TCInit(); 
        lcd_init(); 
        VS1003B_Init();
        w1_init();
        LCD_BL_ON; 
         
        rtc.hour = 12;
        rtc.min = 0;
        rtc.sec = 0;
        rtc.year = 2010;
        rtc.month = 9;
        rtc.mday = 27;
        rtc_settime(&rtc);
         
        LCDSetFontColor(LCD_COL_BLUE);
        LCDPrintStr(5,3,"Testing ELT240x320 8BIT",LCD_MODE_FULL);
        LCDPrintStr(6,4,"With ATMEGA128",LCD_MODE_FULL);
        LCDSetBold(1);
        LCDSetFontColor(LCD_COL_RED); 
        LCDPrintStr(7,5,"BY Hadi.Asadi ;-)",LCD_MODE_FULL); 
        LCDSetBold(0);
        LCDSetFontColor(LCD_COL_BLUE);
        devices = w1_search(0xf0,ds_data);
        sprintf(data,"%-u DS1820 DETECTED ",devices);
        LCDPrintStr(10,5,data,LCD_MODE_FULL);
         
        delay_ms(500);  
        LCDSetFontColor(LCD_COL_BLUE);
        LCDSetBold(1);
        AppCalibrateScreen(3);        
        reset(CHG_DDR,CHG_BIT); 
         
        while (1)
                {   
                while(1)
                        {
                        if(OCR1AL)pos = scan_pen();
                        if(f_pos && pos.on)
                        	pos.x = pos.y = 0;
                        else
                        	f_pos = 0;	 
                        if (!pos.on)
                                {
                                rtc_gettime(&rtc);
                                miltoshmcv(&rtc);
                                LCDSetFontColor(LCD_COL_BLACK);
                                LCDSetBold(0);  
                                sprintf(data,"%u/%u/%u  ",rtc.year,rtc.month,rtc.mday);
                                LCDPrintStr(19,0,data,LCD_MODE_FULL);
                                if(rtc.sec > 10 && rtc.sec < 20 && devices)
                                        { 
                                        temp = ds1820_temperature_10(&ds_data[0]);
                                        sprintf(data,"%-i.%-u c   ",temp/10,abs(temp%10));
                                        LCDPrintStr(19,14,data,LCD_MODE_FULL); 
                                        }
                                else
                                        {   
                                        sprintf(data,"%u:%u:%u    ",rtc.hour,rtc.min,rtc.sec);
                                        LCDPrintStr(19,14,data,LCD_MODE_FULL);
                                        }
                                sprintf(data,"VB:%u.%2u  ",VBAT/100,VBAT%100);
                                if(VBAT%100 < 10)data[5] = '0';
                                LCDPrintStr(0,0,data,LCD_MODE_FULL);
                                }
                                
                        switch (step) 
                                {
                                case 0:
                                        f_mount(0,&fs);
                                        res = disk_initialize(0);
                                        if(res == FR_OK)
                                                {
                                                LCDCLS();
                                                Cdir[0] = 0;
                                                step++;
                                                volume = 40;
                                                }
                                        else delay_ms(100);
                                break;
                                case 1:
                                        nlist = get_list(Cdir);
                                        volome_cotrol(volume);
                                        if(nlist > 12)LCD_VN = 12; else LCD_VN = nlist;
                                        if (!pos.on)pos.x = pos.y = 0; 
                                        listindex = ScrollBar(215,230,32,255,pos.y,nlist);
                                        LCDFillRect(32,200,30,260,LCD_COL_WHITE,LCD_MODE_FULL);
                                        LCDSetBold(2);                                        
                                        LCDSetFontColor(LCD_COL_GREEN);
                                        LCDPrintStr(2,3,Cdir,LCD_MODE_FULL);
                                        sprintf(data,"%u Items ",nlist);
                                        LCDPrintStr(3,3,data,LCD_MODE_FULL);
                                        LCDSetFontColor(LCD_COL_BLUE);
                                        for (Clist=0;Clist<LCD_VN;Clist++)
                                                { 
                                                if(ListTbl[Clist+listindex][_MAX_LFN] == AM_DIR)
                                                        LCDSetBold(1);
                                                else
                                                        LCDSetBold(0);
                                                LCDPrintStr(Clist+4,4,ListTbl[Clist+listindex],LCD_MODE_FULL);
                                                }
                                        step++;
                                break; 
                                case 2: 
                                        if (pos.on)
                                        	{
                                        	if(canter < 250)canter ++; 
                                                }
                                        else	canter = 0;
                                        if (canter > 50)
                                                {
                                                canter = 0;
                                                if(pos.x < 30 && pos.y < 120)
                                                        {
                                                        volume = pos.y;
                                                        volome_cotrol(volume);
                                                        }
                                                else if(pos.x > 200 && pos.y < 260)
                                                        {
                                                        listindex = ScrollBar(215,230,32,255,pos.y,nlist);
                                                        LCDFillRect(40,200,64,260,LCD_COL_WHITE,LCD_MODE_FULL);
                                                        LCDSetFontColor(LCD_COL_BLUE); 
                                                        for (Clist=0;Clist<LCD_VN;Clist++)
                                                                { 
                                                                if(ListTbl[Clist+listindex][_MAX_LFN] == AM_DIR)
                                                                        LCDSetBold(1);
                                                                else
                                                                        LCDSetBold(0);
                                                                LCDPrintStr(Clist+4,4,ListTbl[Clist+listindex],LCD_MODE_FULL);
                                                                }
                                                        }
                                                else if(pos.x > 32 && pos.x < 180 && pos.y > 25 && pos.y < 50)
                                                	{ 
                                                        s = strrpos(Cdir,'/');
                                                        if(s > strlen(Cdir))
                                                        	Cdir[0] = 0;
                                                        else  
                                                        	{
                                                                Cdir[s] = 0;
                                                                //strcpy(str ,"");
                                                                //strncpy(str,Cdir,s); 
                                                                //strcpy(Cdir,str);
                                                                }
                                                        step = 1; 
                                                        f_pos = 1;
                                                        }
                                                else if(pos.x > 32 && pos.x < 180 && pos.y > 50 && pos.y < 256)
                                                        { 
                                                        LCDPrintCh(Clist+listindex+4,3,' ',LCD_MODE_FULL);
                                                        Clist = (uint16)(((pos.y/16)+listindex)-4);
                                                        if(Clist < nlist)
                                                                {
                                                                if(ListTbl[Clist][_MAX_LFN] == AM_DIR)
                                                                        {
                                                                        if(strlen(Cdir))strcatf(Cdir,"/");
                                                                        strcat(Cdir ,ListTbl[Clist]);
                                                                        step = 1; 
                                                                        f_pos = 1;
                                                                        }
                                                                else
                                                                	{
                                                                        f_pos = 1;
                                                                        replay:
                                                                        if(Clist < nlist)
                                                                        	{
                                                                        	strcpy(Cfile,Cdir);
                                                                        	strcatf(Cfile,"/");
                                                                        	strcat(Cfile ,ListTbl[Clist]);
                                                                                }
                                                                        if(strstrf(Cfile, ".BMP") || strstrf(Cfile, ".bmp"))
                                                                        	{
                                                                                res = bmpFile(Cfile);
                                                                                if(res == FR_OK ) 
                                                                                        {
                                                                                        if(!Time2)LCDCLS();
                                                                                        LCDPrintStr(0,0,Cfile,LCD_MODE_INVERSE);
                                                                                        bmpShow( 0, 0);
                                                                                        delay_ms(100); 
                                                                                        pos.on = 0; 
                                                                                        Time2 = 20;
                                                                                        t_lcd = 100;
                                                                                        while (!pos.on && Time2 > 0)
                                                                                                {
                                                                                                pos = scan_pen();
                                                                                                }
                                                                                        if(!Time2 && Clist < nlist)
                                                                                        	{ 
                                                                                                Clist++;
                                                                                        	strcpyf(Cfile,""); 
                                                                                                Time2 = 20;
                                                                                        	goto replay;
                                                                                                }
                                                                                        step = 1;
                                                                                        LCDCLS();
                                                                                        }
                                                                                else
                                                                                        {        
                                                                                        if(Clist < nlist)
                                                                                        	{
                                                                                                Clist++;
                                                                                        	strcpyf(Cfile,"");
                                                                                        	goto replay;
                                                                                                }
                                                                                        else
                                                                                        	{
                                                                                        	step = 1;
                                                                                        	LCDCLS();
                                                                                        	}
                                                                                        }
                                                                                }
                                                                        else if(strstrf(Cfile, ".MP3") || strstrf(Cfile, ".mp3") ||
                                                                	   	strstrf(Cfile, ".WMA") || strstrf(Cfile, ".wma") || 
                                                                           	strstrf(Cfile, ".WAV") || strstrf(Cfile, ".wav") || 
                                                                           	strstrf(Cfile, ".MID") || strstrf(Cfile, ".mid"))
                                                                        	{
                                                                                key_view(10);
                                                                                if(Clist+listindex < 12)
                                                                                	LCDPrintCh(Clist+listindex+4,3,'>',LCD_MODE_FULL);
                                                                                else
                                                                                	{
                                                                                        if(listindex)
                                                                                                {
                                                                                                LCDFillRect(40,200,64,260,LCD_COL_WHITE,LCD_MODE_FULL);
                                                                                                LCDSetFontColor(LCD_COL_BLUE); 
                                                                                                for (Clist=0;Clist<LCD_VN;Clist++)
                                                                                                        { 
                                                                                                        if(ListTbl[Clist+listindex][_MAX_LFN] == AM_DIR)
                                                                                                                LCDSetBold(1);
                                                                                                        else
                                                                                                                LCDSetBold(0);
                                                                                                        LCDPrintStr(Clist+4,4,ListTbl[Clist+listindex],LCD_MODE_FULL);
                                                                                                        }
                                                                                                }
                                                                                        }
                                                                                step = play_file(Cfile);
                                                                                LCDFillRect(0,240,0,16,LCD_COL_WHITE,LCD_MODE_FULL);
                                                                                LCDFillRect(32,220,16,32,LCD_COL_WHITE,LCD_MODE_FULL);
                                                                                LCDFillRect(0,240,256,320,LCD_COL_WHITE,LCD_MODE_FULL);
                                                                                if(step == 10 && Clist < nlist)
                                                                                	{ 
                                                                                        LCDPrintCh(Clist+listindex+4,3,' ',LCD_MODE_FULL);
                                                                                        Clist++;
                                                                                        strcpyf(Cfile,"");
                                                                                        goto replay;
                                                                                        }
                                                                                else if(step == 11 && Clist > 0)
                                                                                	{   
                                                                                        LCDPrintCh(Clist+listindex+4,3,' ',LCD_MODE_FULL);
                                                                                        Clist--;
                                                                                        strcpyf(Cfile,"");
                                                                                        goto replay;
                                                                                        } 
                                                                                else if(step == 10 || step == 11)step = 1; 
                                                                                f_pos = 0;
                                                                                } 
                                                                        else if(strstrf(Cfile, ".TXT") || strstrf(Cfile, ".txt"))
                                                                        	{
                                                                        	Clist++;
                                                                                strcpyf(Cfile,"");
                                                                                goto replay;
                                                                              	} 
                                                                        else
                                                                        	{
                                                                                if(Clist < nlist)
                                                                                        { 
                                                                                        LCDPrintCh(Clist+listindex+4,3,' ',LCD_MODE_FULL);
                                                                                        Clist++;
                                                                                        strcpyf(Cfile,"");
                                                                                        goto replay;
                                                                                        }
                                                                                else
                                                                                	{
                                                                                	step = 1;
                                                                                	LCDCLS();
                                                                                        }
                                                                                }  
                                                                        strcpyf(Cfile,""); 
                                                                        }
                                                                }
                                                        }
                                                }       
                                break; 
                                }
                        } 
                }                           
        }